
/*

HNZVC

? = undefined
* = affected
- = unaffected
0 = cleared
1 = set
# = ccr directly affected by instruction
@ = special - carry set if bit 7 is set

*/

#if macintosh
#pragma mark ____0x____
#endif

/* $00 NEG direct ?**** */
static void neg_di( void )
{
	word r,t;
	DIRBYTE(t); r=-t;
	CLR_NZVC; SET_FLAGS8(0,t,r);
	M_WRMEM(eaddr,r);
}

/* $01 ILLEGAL */

/* $02 ILLEGAL */

/* $03 COM direct -**01 */
static void com_di( void )
{
	byte t;
	DIRBYTE(t); t = ~t;
	CLR_NZV; SET_NZ8(t); SEC;
	M_WRMEM(eaddr,t);
}

/* $04 LSR direct -0*-* */
static void lsr_di( void )
{
	byte t;
	DIRBYTE(t); CLR_NZC; cc|=(t&0x01);
	t>>=1; SET_Z8(t);
	M_WRMEM(eaddr,t);
}

/* $05 ILLEGAL */

/* $06 ROR direct -**-* */
static void ror_di( void )
{
	byte t,r;
	DIRBYTE(t); r=(cc&0x01)<<7;
	CLR_NZC; cc|=(t&0x01);
	r |= t>>1; SET_NZ8(r);
	M_WRMEM(eaddr,r);
}

/* $07 ASR direct ?**-* */
static void asr_di( void )
{
	byte t;
	DIRBYTE(t); CLR_NZC; cc|=(t&0x01);
	t>>=1; t|=((t&0x40)<<1);
	SET_NZ8(t);
	M_WRMEM(eaddr,t);
}

/* $08 ASL direct ?**** */
static void asl_di( void )
{
	word t,r;
	DIRBYTE(t); r=t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $09 ROL direct -**** */
static void rol_di( void )
{
	word t,r;
	DIRBYTE(t); r = cc&0x01; r |= t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $0A DEC direct -***- */
static void dec_di( void )
{
	byte t;
	DIRBYTE(t); --t;
	CLR_NZV; SET_FLAGS8D(t);
	M_WRMEM(eaddr,t);
}

/* $0B ILLEGAL */

/* $OC INC direct -***- */
static void inc_di( void )
{
	byte t;
	DIRBYTE(t); ++t;
	CLR_NZV; SET_FLAGS8I(t);
	M_WRMEM(eaddr,t);
}

/* $OD TST direct -**0- */
static void tst_di( void )
{
	byte t;
	DIRBYTE(t); CLR_NZV; SET_NZ8(t);
}

/* $0E JMP direct ----- */
static void jmp_di( void )
{
	DIRECT; pcreg=eaddr;change_pc(pcreg);/* ASG 971005 */
}

/* $0E JMP direct ----- */
static void jmp_di_slap( void )
{
	DIRECT; pcreg=eaddr;cpu_setOPbase16(pcreg); /* LBO 092898 */
}

/* $0F CLR direct -0100 */
static void clr_di( void )
{
	DIRECT; M_WRMEM(eaddr,0);
	CLR_NZVC; SEZ;
}

#if macintosh
#pragma mark ____1x____
#endif

/* $10 FLAG */

/* $11 FLAG */

/* $12 NOP inherent ----- */
static void nop( void )
{
	;
}

/* $13 SYNC inherent ----- */
static void sync6809( void )
{
	/* SYNC should stop processing instructions until an interrupt occurs.
	   A decent fake is probably to force an immediate IRQ. */
	m6809_ICount = 0;
	pending_interrupts |= M6809_SYNC;	/* NS 980101 */
}

/* $14 ILLEGAL */

/* $15 ILLEGAL */

/* $16 LBRA relative ----- */
static void lbra( void )
{
	IMMWORD(eaddr);

	pcreg+=eaddr;change_pc(pcreg);/* ASG 971005 */

	if ( eaddr == 0xfffd ) /* EHC 980508 speed up busy loop */
		m6809_ICount = 0;
}

/* $17 LBSR relative ----- */
static void lbsr( void )
{
	IMMWORD(eaddr); PUSHWORD(pcreg); pcreg+=eaddr;change_pc(pcreg);/* ASG 971005 */
}

/* $18 ILLEGAL */

#if 1
/* $19 DAA inherent (areg) -**0* */
static void daa( void )
{
	byte msn, lsn;
	word t, cf = 0;
	msn=areg & 0xf0; lsn=areg & 0x0f;
	if( lsn>0x09 || cc&0x20 ) cf |= 0x06;
	if( msn>0x80 && lsn>0x09 ) cf |= 0x60;
	if( msn>0x90 || cc&0x01 ) cf |= 0x60;
	t = cf + areg;
	CLR_NZV; /* keep carry from previous operation */
	SET_NZ8((byte)t); SET_C8(t);
	areg = t;
}
#else
/* $19 DAA inherent (areg) -**0* */
static void daa( void )
{
	word t;
	t=areg;
	if (cc&0x20) t+=0x06;
	if ((t&0x0f)>9) t+=0x06;		/* ASG -- this code is broken! $66+$99=$FF -> DAA should = $65, we get $05! */
	if (cc&0x01) t+=0x60;
	if ((t&0xf0)>0x90) t+=0x60;
	if (t&0x100) SEC;
	areg=t;
}
#endif

/* $1A ORCC immediate ##### */
static void orcc( void )
{
	byte t;
	IMMBYTE(t); cc|=t;
}

/* $1B ILLEGAL */

/* $1C ANDCC immediate ##### */
static void andcc( void )
{
	byte t;
	IMMBYTE(t); cc&=t;
}

/* $1D SEX inherent -**0- */
static void sex( void )
{
	word t;
	t = SIGNED(breg); SETDREG(t);
	CLR_NZV; SET_NZ16(t);
}

/* $1E EXG inherent ----- */
static void exg( void )
{
	word t1=0,t2=0;
	byte tb;

	IMMBYTE(tb); GETREG(t1,tb>>4); GETREG(t2,tb&15);
	SETREG(t2,tb>>4); SETREG(t1,tb&15);
}

/* $1F TFR inherent ----- */
static void tfr( void )
{
	byte tb;
	word t=0;

	IMMBYTE(tb); GETREG(t,tb>>4); SETREG(t,tb&15);
}

#if macintosh
#pragma mark ____2x____
#endif

/* $20 BRA relative ----- */
static void bra( void )
{
	byte t;
	IMMBYTE(t);pcreg+=SIGNED(t);change_pc(pcreg);	/* TS 971002 */
	/* JB 970823 - speed up busy loops */
	if (t==0xfe) m6809_ICount = 0;
}

/* $21 BRN relative ----- */
static void brn( void )
{
	byte t;
	IMMBYTE(t);
}

/* $1021 LBRN relative ----- */
static void lbrn( void )
{
	word t;
	IMMWORD(t);
}

/* $22 BHI relative ----- */
static void bhi( void )
{
	byte t;
	BRANCH(!(cc&0x05));
}

/* $1022 LBHI relative ----- */
static void lbhi( void )
{
	word t;
	LBRANCH(!(cc&0x05));
}

/* $23 BLS relative ----- */
static void bls( void )
{
	byte t;
	BRANCH(cc&0x05);
}

/* $1023 LBLS relative ----- */
static void lbls( void )
{
	word t;
	LBRANCH(cc&0x05);
}

/* $24 BCC relative ----- */
static void bcc( void )
{
	byte t;
	BRANCH(!(cc&0x01));
}

/* $1024 LBCC relative ----- */
static void lbcc( void )
{
	word t;
	LBRANCH(!(cc&0x01));
}

/* $25 BCS relative ----- */
static void bcs( void )
{
	byte t;
	BRANCH(cc&0x01);
}

/* $1025 LBCS relative ----- */
static void lbcs( void )
{
	word t;
	LBRANCH(cc&0x01);
}

/* $26 BNE relative ----- */
static void bne( void )
{
	byte t;
	BRANCH(!(cc&0x04));
}

/* $1026 LBNE relative ----- */
static void lbne( void )
{
	word t;
	LBRANCH(!(cc&0x04));
}

/* $27 BEQ relative ----- */
static void beq( void )
{
	byte t;
	BRANCH(cc&0x04);
}

/* $1027 LBEQ relative ----- */
static void lbeq( void )
{
	word t;
	LBRANCH(cc&0x04);
}

/* $28 BVC relative ----- */
static void bvc( void )
{
	byte t;
	BRANCH(!(cc&0x02));
}

/* $1028 LBVC relative ----- */
static void lbvc( void )
{
	word t;
	LBRANCH(!(cc&0x02));
}

/* $29 BVS relative ----- */
static void bvs( void )
{
	byte t;
	BRANCH(cc&0x02);
}

/* $1029 LBVS relative ----- */
static void lbvs( void )
{
	word t;
	LBRANCH(cc&0x02);
}

/* $2A BPL relative ----- */
static void bpl( void )
{
	byte t;
	BRANCH(!(cc&0x08));
}

/* $102A LBPL relative ----- */
static void lbpl( void )
{
	word t;
	LBRANCH(!(cc&0x08));
}

/* $2B BMI relative ----- */
static void bmi( void )
{
	byte t;
	BRANCH(cc&0x08);
}

/* $102B LBMI relative ----- */
static void lbmi( void )
{
	word t;
	LBRANCH(cc&0x08);
}

/* $2C BGE relative ----- */
static void bge( void )
{
	byte t;
	BRANCH(!NXORV);
}

/* $102C LBGE relative ----- */
static void lbge( void )
{
	word t;
	LBRANCH(!NXORV);
}

/* $2D BLT relative ----- */
static void blt( void )
{
	byte t;
	BRANCH(NXORV);
}

/* $102D LBLT relative ----- */
static void lblt( void )
{
	word t;
	LBRANCH(NXORV);
}

/* $2E BGT relative ----- */
static void bgt( void )
{
	byte t;
	BRANCH(!(NXORV||cc&0x04));
}

/* $102E LBGT relative ----- */
static void lbgt( void )
{
	word t;
	LBRANCH(!(NXORV||cc&0x04));
}

/* $2F BLE relative ----- */
static void ble( void )
{
	byte t;
	BRANCH(NXORV||cc&0x04);
}

/* $102F LBLE relative ----- */
static void lble( void )
{
	word t;
	LBRANCH(NXORV||cc&0x04);
}

#if macintosh
#pragma mark ____3x____
#endif

/* $30 LEAX indexed --*-- */
static void leax( void )
{
	xreg=eaddr; CLR_Z; SET_Z(xreg);
}

/* $31 LEAY indexed --*-- */
static void leay( void )
{
	yreg=eaddr; CLR_Z; SET_Z(yreg);
}

/* $32 LEAS indexed ----- */
static void leas( void )
{
	sreg=eaddr;
}

/* $33 LEAU indexed ----- */
static void leau( void )
{
	ureg=eaddr;
}

/* $34 PSHS inherent ----- */
static void pshs( void )
{
	byte t;
	IMMBYTE(t);
	if(t&0x80) PUSHWORD(pcreg);
	if(t&0x40) PUSHWORD(ureg);
	if(t&0x20) PUSHWORD(yreg);
	if(t&0x10) PUSHWORD(xreg);
	if(t&0x08) PUSHBYTE(dpreg);
	if(t&0x04) PUSHBYTE(breg);
	if(t&0x02) PUSHBYTE(areg);
	if(t&0x01) PUSHBYTE(cc);
}

/* 35 PULS inherent ----- */
static void puls( void )
{
	byte t;
	IMMBYTE(t);
	if(t&0x01) PULLBYTE(cc);
	if(t&0x02) PULLBYTE(areg);
	if(t&0x04) PULLBYTE(breg);
	if(t&0x08) PULLBYTE(dpreg);
	if(t&0x10) PULLWORD(xreg);
	if(t&0x20) PULLWORD(yreg);
	if(t&0x40) PULLWORD(ureg);
	if(t&0x80){ PULLWORD(pcreg);change_pc(pcreg); }	/* TS 971002 */
}

/* $36 PSHU inherent ----- */
static void pshu( void )
{
	byte t;
	IMMBYTE(t);
	if(t&0x80) PSHUWORD(pcreg);
	if(t&0x40) PSHUWORD(sreg);
	if(t&0x20) PSHUWORD(yreg);
	if(t&0x10) PSHUWORD(xreg);
	if(t&0x08) PSHUBYTE(dpreg);
	if(t&0x04) PSHUBYTE(breg);
	if(t&0x02) PSHUBYTE(areg);
	if(t&0x01) PSHUBYTE(cc);
}

/* 37 PULU inherent ----- */
static void pulu( void )
{
	byte t;
	IMMBYTE(t);
	if(t&0x01) PULUBYTE(cc);
	if(t&0x02) PULUBYTE(areg);
	if(t&0x04) PULUBYTE(breg);
	if(t&0x08) PULUBYTE(dpreg);
	if(t&0x10) PULUWORD(xreg);
	if(t&0x20) PULUWORD(yreg);
	if(t&0x40) PULUWORD(sreg);
	if(t&0x80) { PULUWORD(pcreg);change_pc(pcreg); }	/* TS 971002 */
}

/* $38 ILLEGAL */

/* $39 RTS inherent ----- */
static void rts( void )
{
	PULLWORD(pcreg);change_pc(pcreg);	/* TS 971002 */
}

/* $3A ABX inherent ----- */
static void abx( void )
{
	xreg += breg;
}

/* $3B RTI inherent ##### */
static void rti( void )
{
	byte t;
/*	ASG 971016 t=cc&0x80; */
	PULLBYTE(cc);
	t=cc&0x80;	/*	ASG 971016 */
	if(t)
	{
		m6809_ICount -= 9;
		PULLBYTE(areg);
		PULLBYTE(breg);
		PULLBYTE(dpreg);
		PULLWORD(xreg);
		PULLWORD(yreg);
		PULLWORD(ureg);
	}
	PULLWORD(pcreg);change_pc(pcreg);	/* TS 971002 */
}

/* $3C CWAI inherent ----1 */
static void cwai( void )
{
	byte t;
	IMMBYTE(t); cc&=t;
	/* CWAI should stack the entire machine state on the hardware stack,
		then wait for an interrupt. We just wait for an interrupt. */
	if ((pending_interrupts & M6809_INT_IRQ) != 0 && (cc & 0x10) == 0)
		return;
	else if ((pending_interrupts & M6809_INT_FIRQ) != 0 && (cc & 0x40) == 0)
		return;
	m6809_ICount = 0;
	pending_interrupts |= M6809_CWAI;	/* NS 980101 */
}

/* $3D MUL inherent --*-@ */
static void mul( void )
{
	word t;
	t=areg*breg;
	CLR_ZC; SET_Z16(t); if(t&0x80) SEC;
	SETDREG(t);
}

/* $3E ILLEGAL */

/* $3F SWI (SWI2 SWI3) absolute indirect ----- */
static void swi( void )
{
	cc|=0x80;
	PUSHWORD(pcreg);
	PUSHWORD(ureg);
	PUSHWORD(yreg);
	PUSHWORD(xreg);
	PUSHBYTE(dpreg);
	PUSHBYTE(breg);
	PUSHBYTE(areg);
	PUSHBYTE(cc);
	cc|=0x50;
	pcreg = M_RDMEM_WORD(0xfffa);change_pc(pcreg);	/* TS 971002 */
}

/* $103F SWI2 absolute indirect ----- */
static void swi2( void )
{
	cc|=0x80;
	PUSHWORD(pcreg);
	PUSHWORD(ureg);
	PUSHWORD(yreg);
	PUSHWORD(xreg);
	PUSHBYTE(dpreg);
	PUSHBYTE(breg);
	PUSHBYTE(areg);
	PUSHBYTE(cc);
	pcreg = M_RDMEM_WORD(0xfff4);change_pc(pcreg);	/* TS 971002 */
}

/* $113F SWI3 absolute indirect ----- */
static void swi3( void )
{
	cc|=0x80;
	PUSHWORD(pcreg);
	PUSHWORD(ureg);
	PUSHWORD(yreg);
	PUSHWORD(xreg);
	PUSHBYTE(dpreg);
	PUSHBYTE(breg);
	PUSHBYTE(areg);
	PUSHBYTE(cc);
	pcreg = M_RDMEM_WORD(0xfff2);change_pc(pcreg);	/* TS 971002 */
}

#if macintosh
#pragma mark ____4x____
#endif

/* $40 NEGA inherent ?**** */
static void nega( void )
{
	word r;
	r=-areg;
	CLR_NZVC; SET_FLAGS8(0,areg,r);
	areg=r;
}

/* $41 ILLEGAL */

/* $42 ILLEGAL */

/* $43 COMA inherent -**01 */
static void coma( void )
{
	areg = ~areg;
	CLR_NZV; SET_NZ8(areg); SEC;
}

/* $44 LSRA inherent -0*-* */
static void lsra( void )
{
	CLR_NZC; cc|=(areg&0x01);
	areg>>=1; SET_Z8(areg);
}

/* $45 ILLEGAL */

/* $46 RORA inherent -**-* */
static void rora( void )
{
	byte r;
	r=(cc&0x01)<<7;
	CLR_NZC; cc|=(areg&0x01);
	r |= areg>>1; SET_NZ8(r);
	areg=r;
}

/* $47 ASRA inherent ?**-* */
static void asra( void )
{
	CLR_NZC; cc|=(areg&0x01);
	areg>>=1; areg|=((areg&0x40)<<1);
	SET_NZ8(areg);
}

/* $48 ASLA inherent ?**** */
static void asla( void )
{
	word r;
	r=areg<<1;
	CLR_NZVC; SET_FLAGS8(areg,areg,r);
	areg=r;
}

/* $49 ROLA inherent -**** */
static void rola( void )
{
	word t,r;
	t = areg; r = cc&0x01; r |= t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	areg=r;
}

/* $4A DECA inherent -***- */
static void deca( void )
{
	--areg;
	CLR_NZV; SET_FLAGS8D(areg);
}

/* $4B ILLEGAL */

/* $4C INCA inherent -***- */
static void inca( void )
{
	++areg;
	CLR_NZV; SET_FLAGS8I(areg);
}

/* $4D TSTA inherent -**0- */
static void tsta( void )
{
	CLR_NZV; SET_NZ8(areg);
}

/* $4E ILLEGAL */

/* $4F CLRA inherent -0100 */
static void clra( void )
{
	areg=0;
	CLR_NZVC; SEZ;
}

#if macintosh
#pragma mark ____5x____
#endif

/* $50 NEGB inherent ?**** */
static void negb( void )
{
	word r;
	r=-breg;
	CLR_NZVC; SET_FLAGS8(0,breg,r);
	breg=r;
}

/* $51 ILLEGAL */

/* $52 ILLEGAL */

/* $53 COMB inherent -**01 */
static void comb( void )
{
	breg = ~breg;
	CLR_NZV; SET_NZ8(breg); SEC;
}

/* $54 LSRB inherent -0*-* */
static void lsrb( void )
{
	CLR_NZC; cc|=(breg&0x01);
	breg>>=1; SET_Z8(breg);
}

/* $55 ILLEGAL */

/* $56 RORB inherent -**-* */
static void rorb( void )
{
	byte r;
	r=(cc&0x01)<<7;
	CLR_NZC; cc|=(breg&0x01);
	r |= breg>>1; SET_NZ8(r);
	breg=r;
}

/* $57 ASRB inherent ?**-* */
static void asrb( void )
{
	CLR_NZC; cc|=(breg&0x01);
	breg>>=1; breg|=((breg&0x40)<<1);
	SET_NZ8(breg);
}

/* $58 ASLB inherent ?**** */
static void aslb( void )
{
	word r;
	r=breg<<1;
	CLR_NZVC; SET_FLAGS8(breg,breg,r);
	breg=r;
}

/* $59 ROLB inherent -**** */
static void rolb( void )
{
	word t,r;
	t = breg; r = cc&0x01; r |= t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	breg=r;
}

/* $5A DECB inherent -***- */
static void decb( void )
{
	--breg;
	CLR_NZV; SET_FLAGS8D(breg);
}

/* $5B ILLEGAL */

/* $5C INCB inherent -***- */
static void incb( void )
{
	++breg;
	CLR_NZV; SET_FLAGS8I(breg);
}

/* $5D TSTB inherent -**0- */
static void tstb( void )
{
	CLR_NZV; SET_NZ8(breg);
}

/* $5E ILLEGAL */

/* $5F CLRB inherent -0100 */
static void clrb( void )
{
	breg=0;
	CLR_NZVC; SEZ;
}

#if macintosh
#pragma mark ____6x____
#endif

/* $60 NEG indexed ?**** */
static void neg_ix( void )
{
	word r,t;
	t=M_RDMEM(eaddr); r=-t;
	CLR_NZVC; SET_FLAGS8(0,t,r);
	M_WRMEM(eaddr,r);
}

/* $61 ILLEGAL */

/* $62 ILLEGAL */

/* $63 COM indexed -**01 */
static void com_ix( void )
{
	byte t;
	t = ~M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(t); SEC;
	M_WRMEM(eaddr,t);
}

/* $64 LSR indexed -0*-* */
static void lsr_ix( void )
{
	byte t;
	t=M_RDMEM(eaddr); CLR_NZC; cc|=(t&0x01);
	t>>=1; SET_Z8(t);
	M_WRMEM(eaddr,t);
}

/* $65 ILLEGAL */

/* $66 ROR indexed -**-* */
static void ror_ix( void )
{
	byte t,r;
	t=M_RDMEM(eaddr); r=(cc&0x01)<<7;
	CLR_NZC; cc|=(t&0x01);
	r |= t>>1; SET_NZ8(r);
	M_WRMEM(eaddr,r);
}

/* $67 ASR indexed ?**-* */
static void asr_ix( void )
{
	byte t;
	t=M_RDMEM(eaddr); CLR_NZC; cc|=(t&0x01);
	t>>=1; t|=((t&0x40)<<1);
	SET_NZ8(t);
	M_WRMEM(eaddr,t);
}

/* $68 ASL indexed ?**** */
static void asl_ix( void )
{
	word t,r;
	t=M_RDMEM(eaddr); r=t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $69 ROL indexed -**** */
static void rol_ix( void )
{
	word t,r;
	t=M_RDMEM(eaddr); r = cc&0x01; r |= t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $6A DEC indexed -***- */
static void dec_ix( void )
{
	byte t;
	t=M_RDMEM(eaddr)-1;
	CLR_NZV; SET_FLAGS8D(t);
	M_WRMEM(eaddr,t);
}

/* $6B ILLEGAL */

/* $6C INC indexed -***- */
static void inc_ix( void )
{
	byte t;
	t=M_RDMEM(eaddr)+1;
	CLR_NZV; SET_FLAGS8I(t);
	M_WRMEM(eaddr,t);
}

/* $6D TST indexed -**0- */
static void tst_ix( void )
{
	byte t;
	t=M_RDMEM(eaddr); CLR_NZV; SET_NZ8(t);
}

/* $6E JMP indexed ----- */
static void jmp_ix( void )
{
	pcreg=eaddr;change_pc(pcreg);	/* TS 971002 */
}

/* $6E JMP indexed ----- */
static void jmp_ix_slap( void )
{
	pcreg=eaddr;cpu_setOPbase16(pcreg);	/* LBO 092898 */
}

/* $6F CLR indexed -0100 */
static void clr_ix( void )
{
	M_WRMEM(eaddr,0);
	CLR_NZVC; SEZ;
}

#if macintosh
#pragma mark ____7x____
#endif

/* $70 NEG extended ?**** */
static void neg_ex( void )
{
	word r,t;
	EXTBYTE(t); r=-t;
	CLR_NZVC; SET_FLAGS8(0,t,r);
	M_WRMEM(eaddr,r);
}

/* $71 ILLEGAL */

/* $72 ILLEGAL */

/* $73 COM extended -**01 */
static void com_ex( void )
{
	byte t;
	EXTBYTE(t); t = ~t;
	CLR_NZV; SET_NZ8(t); SEC;
	M_WRMEM(eaddr,t);
}

/* $74 LSR extended -0*-* */
static void lsr_ex( void )
{
	byte t;
	EXTBYTE(t); CLR_NZC; cc|=(t&0x01);
	t>>=1; SET_Z8(t);
	M_WRMEM(eaddr,t);
}

/* $75 ILLEGAL */

/* $76 ROR extended -**-* */
static void ror_ex( void )
{
	byte t,r;
	EXTBYTE(t); r=(cc&0x01)<<7;
	CLR_NZC; cc|=(t&0x01);
	r |= t>>1; SET_NZ8(r);
	M_WRMEM(eaddr,r);
}

/* $77 ASR extended ?**-* */
static void asr_ex( void )
{
	byte t;
	EXTBYTE(t); CLR_NZC; cc|=(t&0x01);
	t>>=1; t|=((t&0x40)<<1);
	SET_NZ8(t);
	M_WRMEM(eaddr,t);
}

/* $78 ASL extended ?**** */
static void asl_ex( void )
{
	word t,r;
	EXTBYTE(t); r=t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $79 ROL extended -**** */
static void rol_ex( void )
{
	word t,r;
	EXTBYTE(t); r = cc&0x01; r |= t<<1;
	CLR_NZVC; SET_FLAGS8(t,t,r);
	M_WRMEM(eaddr,r);
}

/* $7A DEC extended -***- */
static void dec_ex( void )
{
	byte t;
	EXTBYTE(t); --t;
	CLR_NZV; SET_FLAGS8D(t);
	M_WRMEM(eaddr,t);
}

/* $7B ILLEGAL */

/* $7C INC extended -***- */
static void inc_ex( void )
{
	byte t;
	EXTBYTE(t); ++t;
	CLR_NZV; SET_FLAGS8I(t);
	M_WRMEM(eaddr,t);
}

/* $7D TST extended -**0- */
static void tst_ex( void )
{
	byte t;
	EXTBYTE(t); CLR_NZV; SET_NZ8(t);
}

/* $7E JMP extended ----- */
static void jmp_ex( void )
{
	EXTENDED; pcreg=eaddr;change_pc(pcreg);	/* TS 971002 */
}

/* $7E JMP extended ----- */
static void jmp_ex_slap( void )
{
	EXTENDED; pcreg=eaddr;cpu_setOPbase16(pcreg);	/* LBO 092898 */
}

/* $7F CLR extended -0100 */
static void clr_ex( void )
{
	EXTENDED; M_WRMEM(eaddr,0);
	CLR_NZVC; SEZ;
}


#if macintosh
#pragma mark ____8x____
#endif

/* $80 SUBA immediate ?**** */
static void suba_im( void )
{
	word	t,r;
	IMMBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $81 CMPA immediate ?**** */
static void cmpa_im( void )
{
	word	t,r;
	IMMBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
}

/* $82 SBCA immediate ?**** */
static void sbca_im( void )
{
	word	t,r;
	IMMBYTE(t); r = areg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $83 SUBD (CMPD CMPU) immediate -**** */
static void subd_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $1083 CMPD immediate -**** */
static void cmpd_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $1183 CMPU immediate -**** */
static void cmpu_im( void )
{
	dword r,b;
	IMMWORD(b); r = ureg-b;
	CLR_NZVC; SET_FLAGS16(ureg,b,r);
}

/* $84 ANDA immediate -**0- */
static void anda_im( void )
{
	byte t;
	IMMBYTE(t); areg &= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $85 BITA immediate -**0- */
static void bita_im( void )
{
	byte t,r;
	IMMBYTE(t); r = areg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $86 LDA immediate -**0- */
static void lda_im( void )
{
	IMMBYTE(areg);
	CLR_NZV; SET_NZ8(areg);
}

/* is this a legal instruction? */
/* $87 STA immediate -**0- */
static void sta_im( void )
{
	CLR_NZV; SET_NZ8(areg);
	IMM8; M_WRMEM(eaddr,areg);
}

/* $88 EORA immediate -**0- */
static void eora_im( void )
{
	byte t;
	IMMBYTE(t); areg ^= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $89 ADCA immediate ***** */
static void adca_im( void )
{
	word t,r;
	IMMBYTE(t); r = areg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $8A ORA immediate -**0- */
static void ora_im( void )
{
	byte t;
	IMMBYTE(t); areg |= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $8B ADDA immediate ***** */
static void adda_im( void )
{
	word t,r;
	IMMBYTE(t); r = areg+t;
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $8C CMPX (CMPY CMPS) immediate -**** */
static void cmpx_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = xreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $108C CMPY immediate -**** */
static void cmpy_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = yreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $118C CMPS immediate -**** */
static void cmps_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = sreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $8D BSR ----- */
static void bsr( void )
{
	byte t;
	IMMBYTE(t); PUSHWORD(pcreg); pcreg += SIGNED(t);change_pc(pcreg);	/* TS 971002 */
}

/* $8E LDX (LDY) immediate -**0- */
static void ldx_im( void )
{
	IMMWORD(xreg);
	CLR_NZV; SET_NZ16(xreg);
}

/* $108E LDY immediate -**0- */
static void ldy_im( void )
{
	IMMWORD(yreg);
	CLR_NZV; SET_NZ16(yreg);
}

/* is this a legal instruction? */
/* $8F STX (STY) immediate -**0- */
static void stx_im( void )
{
	CLR_NZV; SET_NZ16(xreg);
	IMM16; M_WRMEM_WORD(eaddr,xreg);
}

/* is this a legal instruction? */
/* $108F STY immediate -**0- */
static void sty_im( void )
{
	CLR_NZV; SET_NZ16(yreg);
	IMM16; M_WRMEM_WORD(eaddr,yreg);
}

#if macintosh
#pragma mark ____9x____
#endif

/* $90 SUBA direct ?**** */
static void suba_di( void )
{
	word	t,r;
	DIRBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $91 CMPA direct ?**** */
static void cmpa_di( void )
{
	word	t,r;
	DIRBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
}

/* $92 SBCA direct ?**** */
static void sbca_di( void )
{
	word	t,r;
	DIRBYTE(t); r = areg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $93 SUBD (CMPD CMPU) direct -**** */
static void subd_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $1093 CMPD direct -**** */
static void cmpd_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $1193 CMPU direct -**** */
static void cmpu_di( void )
{
	dword r,b;
	DIRWORD(b); r = ureg-b;
	CLR_NZVC; SET_FLAGS16(ureg,b,r);
}

/* $94 ANDA direct -**0- */
static void anda_di( void )
{
	byte t;
	DIRBYTE(t); areg &= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $95 BITA direct -**0- */
static void bita_di( void )
{
	byte t,r;
	DIRBYTE(t); r = areg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $96 LDA direct -**0- */
static void lda_di( void )
{
	DIRBYTE(areg);
	CLR_NZV; SET_NZ8(areg);
}

/* $97 STA direct -**0- */
static void sta_di( void )
{
	CLR_NZV; SET_NZ8(areg);
	DIRECT; M_WRMEM(eaddr,areg);
}

/* $98 EORA direct -**0- */
static void eora_di( void )
{
	byte t;
	DIRBYTE(t); areg ^= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $99 ADCA direct ***** */
static void adca_di( void )
{
	word t,r;
	DIRBYTE(t); r = areg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $9A ORA direct -**0- */
static void ora_di( void )
{
	byte t;
	DIRBYTE(t); areg |= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $9B ADDA direct ***** */
static void adda_di( void )
{
	word t,r;
	DIRBYTE(t); r = areg+t;
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $9C CMPX (CMPY CMPS) direct -**** */
static void cmpx_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = xreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $109C CMPY direct -**** */
static void cmpy_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = yreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $119C CMPS direct -**** */
static void cmps_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = sreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $9D JSR direct ----- */
static void jsr_di( void )
{
	DIRECT; PUSHWORD(pcreg);
	pcreg = eaddr;change_pc(pcreg);	/* TS 971002 */
}

/* $9D JSR direct ----- */
static void jsr_di_slap( void )
{
	DIRECT; PUSHWORD(pcreg);
	pcreg = eaddr;cpu_setOPbase16(pcreg);	/* LBO 092898 */
}

/* $9E LDX (LDY) direct -**0- */
static void ldx_di( void )
{
	DIRWORD(xreg);
	CLR_NZV; SET_NZ16(xreg);
}

/* $109E LDY direct -**0- */
static void ldy_di( void )
{
	DIRWORD(yreg);
	CLR_NZV; SET_NZ16(yreg);
}

/* $9F STX (STY) direct -**0- */
static void stx_di( void )
{
	CLR_NZV; SET_NZ16(xreg);
	DIRECT; M_WRMEM_WORD(eaddr,xreg);
}

/* $109F STY direct -**0- */
static void sty_di( void )
{
	CLR_NZV; SET_NZ16(yreg);
	DIRECT; M_WRMEM_WORD(eaddr,yreg);
}

#if macintosh
#pragma mark ____Ax____
#endif


/* $a0 SUBA indexed ?**** */
static void suba_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $a1 CMPA indexed ?**** */
static void cmpa_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
}

/* $a2 SBCA indexed ?**** */
static void sbca_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = areg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $a3 SUBD (CMPD CMPU) indexed -**** */
static void subd_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $10a3 CMPD indexed -**** */
static void cmpd_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $11a3 CMPU indexed -**** */
static void cmpu_ix( void )
{
	dword r,b;
	b = M_RDMEM_WORD(eaddr); r = ureg-b;
	CLR_NZVC; SET_FLAGS16(ureg,b,r);
}

/* $a4 ANDA indexed -**0- */
static void anda_ix( void )
{
	areg &= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(areg);
}

/* $a5 BITA indexed -**0- */
static void bita_ix( void )
{
	byte r;
	r = areg&M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(r);
}

/* $a6 LDA indexed -**0- */
static void lda_ix( void )
{
	areg = M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(areg);
}

/* $a7 STA indexed -**0- */
static void sta_ix( void )
{
	CLR_NZV; SET_NZ8(areg);
	M_WRMEM(eaddr,areg);
}

/* $a8 EORA indexed -**0- */
static void eora_ix( void )
{
	areg ^= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(areg);
}

/* $a9 ADCA indexed ***** */
static void adca_ix( void )
{
	word t,r;
	t = M_RDMEM(eaddr); r = areg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $aA ORA indexed -**0- */
static void ora_ix( void )
{
	areg |= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(areg);
}

/* $aB ADDA indexed ***** */
static void adda_ix( void )
{
	word t,r;
	t = M_RDMEM(eaddr); r = areg+t;
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $aC CMPX (CMPY CMPS) indexed -**** */
static void cmpx_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = xreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $10aC CMPY indexed -**** */
static void cmpy_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = yreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $11aC CMPS indexed -**** */
static void cmps_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = sreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $aD JSR indexed ----- */
static void jsr_ix( void )
{
	PUSHWORD(pcreg);
	pcreg = eaddr;change_pc(pcreg);	/* TS 971002 */
}

/* $aD JSR indexed ----- */
static void jsr_ix_slap( void )
{
	PUSHWORD(pcreg);
	pcreg = eaddr;cpu_setOPbase16(pcreg);	/* LBO 092898 */
}

/* $aE LDX (LDY) indexed -**0- */
static void ldx_ix( void )
{
	xreg = M_RDMEM_WORD(eaddr);
	CLR_NZV; SET_NZ16(xreg);
}

/* $10aE LDY indexed -**0- */
static void ldy_ix( void )
{
	yreg = M_RDMEM_WORD(eaddr);
	CLR_NZV; SET_NZ16(yreg);
}

/* $aF STX (STY) indexed -**0- */
static void stx_ix( void )
{
	CLR_NZV; SET_NZ16(xreg);
	M_WRMEM_WORD(eaddr,xreg);
}

/* $10aF STY indexed -**0- */
static void sty_ix( void )
{
	CLR_NZV; SET_NZ16(yreg);
	M_WRMEM_WORD(eaddr,yreg);
}

#if macintosh
#pragma mark ____Bx____
#endif

/* $b0 SUBA extended ?**** */
static void suba_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $b1 CMPA extended ?**** */
static void cmpa_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = areg-t;
	CLR_NZVC; SET_FLAGS8(areg,t,r);
}

/* $b2 SBCA extended ?**** */
static void sbca_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = areg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(areg,t,r);
	areg = r;
}

/* $b3 SUBD (CMPD CMPU) extended -**** */
static void subd_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $10b3 CMPD extended -**** */
static void cmpd_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = GETDREG; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $11b3 CMPU extended -**** */
static void cmpu_ex( void )
{
	dword r,b;
	EXTWORD(b); r = ureg-b;
	CLR_NZVC; SET_FLAGS16(ureg,b,r);
}

/* $b4 ANDA extended -**0- */
static void anda_ex( void )
{
	byte t;
	EXTBYTE(t); areg &= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $b5 BITA extended -**0- */
static void bita_ex( void )
{
	byte t,r;
	EXTBYTE(t); r = areg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $b6 LDA extended -**0- */
static void lda_ex( void )
{
	EXTBYTE(areg);
	CLR_NZV; SET_NZ8(areg);
}

/* $b7 STA extended -**0- */
static void sta_ex( void )
{
	CLR_NZV; SET_NZ8(areg);
	EXTENDED; M_WRMEM(eaddr,areg);
}

/* $b8 EORA extended -**0- */
static void eora_ex( void )
{
	byte t;
	EXTBYTE(t); areg ^= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $b9 ADCA extended ***** */
static void adca_ex( void )
{
	word t,r;
	EXTBYTE(t); r = areg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $bA ORA extended -**0- */
static void ora_ex( void )
{
	byte t;
	EXTBYTE(t); areg |= t;
	CLR_NZV; SET_NZ8(areg);
}

/* $bB ADDA extended ***** */
static void adda_ex( void )
{
	word t,r;
	EXTBYTE(t); r = areg+t;
	CLR_HNZVC; SET_FLAGS8(areg,t,r); SET_H(areg,t,r);
	areg = r;
}

/* $bC CMPX (CMPY CMPS) extended -**** */
static void cmpx_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = xreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $10bC CMPY extended -**** */
static void cmpy_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = yreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $11bC CMPS extended -**** */
static void cmps_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = sreg; r = d-b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
}

/* $bD JSR extended ----- */
static void jsr_ex( void )
{
	EXTENDED; PUSHWORD(pcreg);
	pcreg = eaddr;change_pc(pcreg);	/* TS 971002 */
}

/* $bD JSR extended - Slapstic ----- */
static void jsr_ex_slap( void )
{
	EXTENDED; PUSHWORD(pcreg);
	pcreg = eaddr;cpu_setOPbase16(pcreg);	/* LBO 092898 */
}

/* $bE LDX (LDY) extended -**0- */
static void ldx_ex( void )
{
	EXTWORD(xreg);
	CLR_NZV; SET_NZ16(xreg);
}

/* $10bE LDY extended -**0- */
static void ldy_ex( void )
{
	EXTWORD(yreg);
	CLR_NZV; SET_NZ16(yreg);
}

/* $bF STX (STY) extended -**0- */
static void stx_ex( void )
{
	CLR_NZV; SET_NZ16(xreg);
	EXTENDED; M_WRMEM_WORD(eaddr,xreg);
}

/* $10bF STY extended -**0- */
static void sty_ex( void )
{
	CLR_NZV; SET_NZ16(yreg);
	EXTENDED; M_WRMEM_WORD(eaddr,yreg);
}


#if macintosh
#pragma mark ____Cx____
#endif

/* $c0 SUBB immediate ?**** */
static void subb_im( void )
{
	word	t,r;
	IMMBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $c1 CMPB immediate ?**** */
static void cmpb_im( void )
{
	word	t,r;
	IMMBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
}

/* $c2 SBCB immediate ?**** */
static void sbcb_im( void )
{
	word	t,r;
	IMMBYTE(t); r = breg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $c3 ADDD immediate -**** */
static void addd_im( void )
{
	dword r,d,b;
	IMMWORD(b); d = GETDREG; r = d+b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $c4 ANDB immediate -**0- */
static void andb_im( void )
{
	byte t;
	IMMBYTE(t); breg &= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $c5 BITB immediate -**0- */
static void bitb_im( void )
{
	byte t,r;
	IMMBYTE(t); r = breg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $c6 LDB immediate -**0- */
static void ldb_im( void )
{
	IMMBYTE(breg);
	CLR_NZV; SET_NZ8(breg);
}

/* is this a legal instruction? */
/* $c7 STB immediate -**0- */
static void stb_im( void )
{
	CLR_NZV; SET_NZ8(breg);
	IMM8; M_WRMEM(eaddr,breg);
}

/* $c8 EORB immediate -**0- */
static void eorb_im( void )
{
	byte t;
	IMMBYTE(t); breg ^= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $c9 ADCB immediate ***** */
static void adcb_im( void )
{
	word t,r;
	IMMBYTE(t); r = breg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $cA ORB immediate -**0- */
static void orb_im( void )
{
	byte t;
	IMMBYTE(t); breg |= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $cB ADDB immediate ***** */
static void addb_im( void )
{
	word t,r;
	IMMBYTE(t); r = breg+t;
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $cC LDD immediate -**0- */
static void ldd_im( void )
{
	word t;
	IMMWORD(t); SETDREG(t);
	CLR_NZV; SET_NZ16(t);
}

/* is this a legal instruction? */
/* $cD STD immediate -**0- */
static void std_im( void )
{
	word t;
	IMM16; t=GETDREG;
	CLR_NZV; SET_NZ16(t);
	M_WRMEM_WORD(eaddr,t);
}

/* $cE LDU (LDS) immediate -**0- */
static void ldu_im( void )
{
	IMMWORD(ureg);
	CLR_NZV; SET_NZ16(ureg);
}

/* $10cE LDS immediate -**0- */
static void lds_im( void )
{
	IMMWORD(sreg);
	CLR_NZV; SET_NZ16(sreg);
}

/* is this a legal instruction? */
/* $cF STU (STS) immediate -**0- */
static void stu_im( void )
{
	CLR_NZV; SET_NZ16(ureg);
	IMM16; M_WRMEM_WORD(eaddr,ureg);
}

/* is this a legal instruction? */
/* $10cF STS immediate -**0- */
static void sts_im( void )
{
	CLR_NZV; SET_NZ16(sreg);
	IMM16; M_WRMEM_WORD(eaddr,sreg);
}


#if macintosh
#pragma mark ____Dx____
#endif

/* $d0 SUBB direct ?**** */
static void subb_di( void )
{
	word	t,r;
	DIRBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $d1 CMPB direct ?**** */
static void cmpb_di( void )
{
	word	t,r;
	DIRBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
}

/* $d2 SBCB direct ?**** */
static void sbcb_di( void )
{
	word	t,r;
	DIRBYTE(t); r = breg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $d3 ADDD direct -**** */
static void addd_di( void )
{
	dword r,d,b;
	DIRWORD(b); d = GETDREG; r = d+b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $d4 ANDB direct -**0- */
static void andb_di( void )
{
	byte t;
	DIRBYTE(t); breg &= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $d5 BITB direct -**0- */
static void bitb_di( void )
{
	byte t,r;
	DIRBYTE(t); r = breg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $d6 LDB direct -**0- */
static void ldb_di( void )
{
	DIRBYTE(breg);
	CLR_NZV; SET_NZ8(breg);
}

/* $d7 STB direct -**0- */
static void stb_di( void )
{
	CLR_NZV; SET_NZ8(breg);
	DIRECT; M_WRMEM(eaddr,breg);
}

/* $d8 EORB direct -**0- */
static void eorb_di( void )
{
	byte t;
	DIRBYTE(t); breg ^= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $d9 ADCB direct ***** */
static void adcb_di( void )
{
	word t,r;
	DIRBYTE(t); r = breg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $dA ORB direct -**0- */
static void orb_di( void )
{
	byte t;
	DIRBYTE(t); breg |= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $dB ADDB direct ***** */
static void addb_di( void )
{
	word t,r;
	DIRBYTE(t); r = breg+t;
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $dC LDD direct -**0- */
static void ldd_di( void )
{
	word t;
	DIRWORD(t); SETDREG(t);
	CLR_NZV; SET_NZ16(t);
}

/* $dD STD direct -**0- */
static void std_di( void )
{
	word t;
	DIRECT; t=GETDREG;
	CLR_NZV; SET_NZ16(t);
	M_WRMEM_WORD(eaddr,t);
}

/* $dE LDU (LDS) direct -**0- */
static void ldu_di( void )
{
	DIRWORD(ureg);
	CLR_NZV; SET_NZ16(ureg);
}

/* $10dE LDS direct -**0- */
static void lds_di( void )
{
	DIRWORD(sreg);
	CLR_NZV; SET_NZ16(sreg);
}

/* $dF STU (STS) direct -**0- */
static void stu_di( void )
{
	CLR_NZV; SET_NZ16(ureg);
	DIRECT; M_WRMEM_WORD(eaddr,ureg);
}

/* $10dF STS direct -**0- */
static void sts_di( void )
{
	CLR_NZV; SET_NZ16(sreg);
	DIRECT; M_WRMEM_WORD(eaddr,sreg);
}

#if macintosh
#pragma mark ____Ex____
#endif


/* $e0 SUBB indexed ?**** */
static void subb_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $e1 CMPB indexed ?**** */
static void cmpb_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
}

/* $e2 SBCB indexed ?**** */
static void sbcb_ix( void )
{
	word	t,r;
	t = M_RDMEM(eaddr); r = breg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $e3 ADDD indexed -**** */
static void addd_ix( void )
{
	dword r,d,b;
	b = M_RDMEM_WORD(eaddr); d = GETDREG; r = d+b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $e4 ANDB indexed -**0- */
static void andb_ix( void )
{
	breg &= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(breg);
}

/* $e5 BITB indexed -**0- */
static void bitb_ix( void )
{
	byte r;
	r = breg&M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(r);
}

/* $e6 LDB indexed -**0- */
static void ldb_ix( void )
{
	breg = M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(breg);
}

/* $e7 STB indexed -**0- */
static void stb_ix( void )
{
	CLR_NZV; SET_NZ8(breg);
	M_WRMEM(eaddr,breg);
}

/* $e8 EORB indexed -**0- */
static void eorb_ix( void )
{
	breg ^= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(breg);
}

/* $e9 ADCB indexed ***** */
static void adcb_ix( void )
{
	word t,r;
	t = M_RDMEM(eaddr); r = breg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $eA ORB indexed -**0- */
static void orb_ix( void )
{
	breg |= M_RDMEM(eaddr);
	CLR_NZV; SET_NZ8(breg);
}

/* $eB ADDB indexed ***** */
static void addb_ix( void )
{
	word t,r;
	t = M_RDMEM(eaddr); r = breg+t;
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $eC LDD indexed -**0- */
static void ldd_ix( void )
{
	word t;
	t = M_RDMEM_WORD(eaddr); SETDREG(t);
	CLR_NZV; SET_NZ16(t);
}

/* $eD STD indexed -**0- */
static void std_ix( void )
{
	word t;
	t=GETDREG;
	CLR_NZV; SET_NZ16(t);
	M_WRMEM_WORD(eaddr,t);
}

/* $eE LDU (LDS) indexed -**0- */
static void ldu_ix( void )
{
	ureg = M_RDMEM_WORD(eaddr);
	CLR_NZV; SET_NZ16(ureg);
}

/* $10eE LDS indexed -**0- */
static void lds_ix( void )
{
	sreg = M_RDMEM_WORD(eaddr);
	CLR_NZV; SET_NZ16(sreg);
}

/* $eF STU (STS) indexed -**0- */
static void stu_ix( void )
{
	CLR_NZV; SET_NZ16(ureg);
	M_WRMEM_WORD(eaddr,ureg);
}

/* $10eF STS indexed -**0- */
static void sts_ix( void )
{
	CLR_NZV; SET_NZ16(sreg);
	M_WRMEM_WORD(eaddr,sreg);
}

#if macintosh
#pragma mark ____Fx____
#endif

/* $f0 SUBB extended ?**** */
static void subb_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $f1 CMPB extended ?**** */
static void cmpb_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = breg-t;
	CLR_NZVC; SET_FLAGS8(breg,t,r);
}

/* $f2 SBCB extended ?**** */
static void sbcb_ex( void )
{
	word	t,r;
	EXTBYTE(t); r = breg-t-(cc&0x01);
	CLR_NZVC; SET_FLAGS8(breg,t,r);
	breg = r;
}

/* $f3 ADDD extended -**** */
static void addd_ex( void )
{
	dword r,d,b;
	EXTWORD(b); d = GETDREG; r = d+b;
	CLR_NZVC; SET_FLAGS16(d,b,r);
	SETDREG(r);
}

/* $f4 ANDB extended -**0- */
static void andb_ex( void )
{
	byte t;
	EXTBYTE(t); breg &= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $f5 BITB extended -**0- */
static void bitb_ex( void )
{
	byte t,r;
	EXTBYTE(t); r = breg&t;
	CLR_NZV; SET_NZ8(r);
}

/* $f6 LDB extended -**0- */
static void ldb_ex( void )
{
	EXTBYTE(breg);
	CLR_NZV; SET_NZ8(breg);
}

/* $f7 STB extended -**0- */
static void stb_ex( void )
{
	CLR_NZV; SET_NZ8(breg);
	EXTENDED; M_WRMEM(eaddr,breg);
}

/* $f8 EORB extended -**0- */
static void eorb_ex( void )
{
	byte t;
	EXTBYTE(t); breg ^= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $f9 ADCB extended ***** */
static void adcb_ex( void )
{
	word t,r;
	EXTBYTE(t); r = breg+t+(cc&0x01);
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $fA ORB extended -**0- */
static void orb_ex( void )
{
	byte t;
	EXTBYTE(t); breg |= t;
	CLR_NZV; SET_NZ8(breg);
}

/* $fB ADDB extended ***** */
static void addb_ex( void )
{
	word t,r;
	EXTBYTE(t); r = breg+t;
	CLR_HNZVC; SET_FLAGS8(breg,t,r); SET_H(breg,t,r);
	breg = r;
}

/* $fC LDD extended -**0- */
static void ldd_ex( void )
{
	word t;
	EXTWORD(t); SETDREG(t);
	CLR_NZV; SET_NZ16(t);
}

/* $fD STD extended -**0- */
static void std_ex( void )
{
	word t;
	EXTENDED; t=GETDREG;
	CLR_NZV; SET_NZ16(t);
	M_WRMEM_WORD(eaddr,t);
}

/* $fE LDU (LDS) extended -**0- */
static void ldu_ex( void )
{
	EXTWORD(ureg);
	CLR_NZV; SET_NZ16(ureg);
}

/* $10fE LDS extended -**0- */
static void lds_ex( void )
{
	EXTWORD(sreg);
	CLR_NZV; SET_NZ16(sreg);
}

/* $fF STU (STS) extended -**0- */
static void stu_ex( void )
{
	CLR_NZV; SET_NZ16(ureg);
	EXTENDED; M_WRMEM_WORD(eaddr,ureg);
}

/* $10fF STS extended -**0- */
static void sts_ex( void )
{
	CLR_NZV; SET_NZ16(sreg);
	EXTENDED; M_WRMEM_WORD(eaddr,sreg);
}

static void illegal( void )
{
}

static void (*m6809_main[0x100])(void) = {
	neg_di,illegal,illegal,com_di,lsr_di,illegal,ror_di,asr_di,
	asl_di,rol_di,dec_di,illegal,inc_di,tst_di,jmp_di,clr_di,
	illegal,illegal,nop,sync6809,illegal,illegal,lbra,lbsr,illegal,
	daa,orcc,illegal,andcc,sex,exg,tfr,bra,brn,bhi,bls,
	bcc,bcs,bne,beq,bvc,bvs,bpl,bmi,bge,blt,bgt,ble,leax,
	leay,leas,leau,pshs,puls,pshu,pulu,illegal,rts,abx,rti,
	cwai,mul,illegal,swi,nega,illegal,illegal,coma,lsra,illegal,
	rora,asra,asla,rola,deca,illegal,inca,tsta,illegal,clra,
	negb,illegal,illegal,comb,lsrb,illegal,rorb,asrb,aslb,rolb,
	decb,illegal,incb,tstb,illegal,clrb,neg_ix,illegal,illegal,
	com_ix,lsr_ix,illegal,ror_ix,asr_ix,asl_ix,rol_ix,dec_ix,illegal,
	inc_ix,tst_ix,jmp_ix,clr_ix,neg_ex,illegal,illegal,com_ex,lsr_ex,
	illegal,ror_ex,asr_ex,asl_ex,rol_ex,dec_ex,illegal,inc_ex,tst_ex,
	jmp_ex,clr_ex,suba_im,cmpa_im,sbca_im,subd_im,anda_im,bita_im,
	lda_im,sta_im,eora_im,adca_im,ora_im,adda_im,cmpx_im,bsr,ldx_im,
	stx_im,suba_di,cmpa_di,sbca_di,subd_di,anda_di,bita_di,lda_di,
	sta_di,eora_di,adca_di,ora_di,adda_di,cmpx_di,jsr_di,ldx_di,
	stx_di,suba_ix,cmpa_ix,sbca_ix,subd_ix,anda_ix,bita_ix,lda_ix,
	sta_ix,eora_ix,adca_ix,ora_ix,adda_ix,cmpx_ix,jsr_ix,ldx_ix,
	stx_ix,suba_ex,cmpa_ex,sbca_ex,subd_ex,anda_ex,bita_ex,lda_ex,
	sta_ex,eora_ex,adca_ex,ora_ex,adda_ex,cmpx_ex,jsr_ex,ldx_ex,
	stx_ex,subb_im,cmpb_im,sbcb_im,addd_im,andb_im,bitb_im,ldb_im,
	stb_im,eorb_im,adcb_im,orb_im,addb_im,ldd_im,std_im,ldu_im,
	stu_im,subb_di,cmpb_di,sbcb_di,addd_di,andb_di,bitb_di,ldb_di,
	stb_di,eorb_di,adcb_di,orb_di,addb_di,ldd_di,std_di,ldu_di,
	stu_di,subb_ix,cmpb_ix,sbcb_ix,addd_ix,andb_ix,bitb_ix,ldb_ix,
	stb_ix,eorb_ix,adcb_ix,orb_ix,addb_ix,ldd_ix,std_ix,ldu_ix,stu_ix,
	subb_ex,cmpb_ex,sbcb_ex,addd_ex,andb_ex,bitb_ex,ldb_ex,stb_ex,
	eorb_ex,adcb_ex,orb_ex,addb_ex,ldd_ex,std_ex,ldu_ex,stu_ex
};

static void (*m6809_pref10[0x100])(void) = {
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 00 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 10 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,lbrn,	lbhi,	lbls,	lbcc,	lbcs,	lbne,	lbeq,		/* 20 */
	lbvc,	lbvs,	lbpl,	lbmi,	lbge,	lblt,	lbgt,	lble,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 30 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,swi2,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 40 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 50 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 60 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 70 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,cmpd_im,illegal,illegal,illegal,illegal,	/* 80 */
	illegal,illegal,illegal,illegal,cmpy_im,illegal,ldy_im, sty_im,
	illegal,illegal,illegal,cmpd_di,illegal,illegal,illegal,illegal,	/* 90 */
	illegal,illegal,illegal,illegal,cmpy_di,illegal,ldy_di, sty_di,
	illegal,illegal,illegal,cmpd_ix,illegal,illegal,illegal,illegal,	/* a0 */
	illegal,illegal,illegal,illegal,cmpy_ix,illegal,ldy_ix, sty_ix,
	illegal,illegal,illegal,cmpd_ex,illegal,illegal,illegal,illegal,	/* b0 */
	illegal,illegal,illegal,illegal,cmpy_ex,illegal,ldy_ex, sty_ex,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* c0 */
	illegal,illegal,illegal,illegal,illegal,illegal,lds_im, sts_im,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* d0 */
	illegal,illegal,illegal,illegal,illegal,illegal,lds_di, sts_di,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* e0 */
	illegal,illegal,illegal,illegal,illegal,illegal,lds_ix, sts_ix,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* f0 */
	illegal,illegal,illegal,illegal,illegal,illegal,lds_ex, sts_ex
};

static void (*m6809_pref11[0x100])(void) = {
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 00 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 10 */
    	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 20 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 30 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,swi3,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 40 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 50 */
    	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 60 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* 70 */
    	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,cmpu_im,illegal,illegal,illegal,illegal,	/* 80 */
	illegal,illegal,illegal,illegal,cmps_im,illegal,illegal,illegal,
	illegal,illegal,illegal,cmpu_di,illegal,illegal,illegal,illegal,	/* 90 */
	illegal,illegal,illegal,illegal,cmps_di,illegal,illegal,illegal,
	illegal,illegal,illegal,cmpu_ix,illegal,illegal,illegal,illegal,	/* a0 */
	illegal,illegal,illegal,illegal,cmps_ix,illegal,illegal,illegal,
	illegal,illegal,illegal,cmpu_ex,illegal,illegal,illegal,illegal,	/* b0 */
	illegal,illegal,illegal,illegal,cmps_ex,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* c0 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* d0 */
    	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* e0 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal,	/* f0 */
	illegal,illegal,illegal,illegal,illegal,illegal,illegal,illegal
};

static byte fetch_0x00(void) { eaddr=xreg;return 1; }
static byte fetch_0x01(void) { eaddr=xreg+1;return 1; }
static byte fetch_0x02(void) { eaddr=xreg+2;return 1; }
static byte fetch_0x03(void) { eaddr=xreg+3;return 1; }
static byte fetch_0x04(void) { eaddr=xreg+4;return 1; }
static byte fetch_0x05(void) { eaddr=xreg+5;return 1; }
static byte fetch_0x06(void) { eaddr=xreg+6;return 1; }
static byte fetch_0x07(void) { eaddr=xreg+7;return 1; }
static byte fetch_0x08(void) { eaddr=xreg+8;return 1; }
static byte fetch_0x09(void) { eaddr=xreg+9;return 1; }
static byte fetch_0x0A(void) { eaddr=xreg+10;return 1; }
static byte fetch_0x0B(void) { eaddr=xreg+11;return 1; }
static byte fetch_0x0C(void) { eaddr=xreg+12;return 1; }
static byte fetch_0x0D(void) { eaddr=xreg+13;return 1; }
static byte fetch_0x0E(void) { eaddr=xreg+14;return 1; }
static byte fetch_0x0F(void) { eaddr=xreg+15;return 1; }
static byte fetch_0x10(void) { eaddr=xreg-16;return 1; }
static byte fetch_0x11(void) { eaddr=xreg-15;return 1; }
static byte fetch_0x12(void) { eaddr=xreg-14;return 1; }
static byte fetch_0x13(void) { eaddr=xreg-13;return 1; }
static byte fetch_0x14(void) { eaddr=xreg-12;return 1; }
static byte fetch_0x15(void) { eaddr=xreg-11;return 1; }
static byte fetch_0x16(void) { eaddr=xreg-10;return 1; }
static byte fetch_0x17(void) { eaddr=xreg-9;return 1; }
static byte fetch_0x18(void) { eaddr=xreg-8;return 1; }
static byte fetch_0x19(void) { eaddr=xreg-7;return 1; }
static byte fetch_0x1A(void) { eaddr=xreg-6;return 1; }
static byte fetch_0x1B(void) { eaddr=xreg-5;return 1; }
static byte fetch_0x1C(void) { eaddr=xreg-4;return 1; }
static byte fetch_0x1D(void) { eaddr=xreg-3;return 1; }
static byte fetch_0x1E(void) { eaddr=xreg-2;return 1; }
static byte fetch_0x1F(void) { eaddr=xreg-1;return 1; }
static byte fetch_0x20(void) { eaddr=yreg;return 1; }
static byte fetch_0x21(void) { eaddr=yreg+1;return 1; }
static byte fetch_0x22(void) { eaddr=yreg+2;return 1; }
static byte fetch_0x23(void) { eaddr=yreg+3;return 1; }
static byte fetch_0x24(void) { eaddr=yreg+4;return 1; }
static byte fetch_0x25(void) { eaddr=yreg+5;return 1; }
static byte fetch_0x26(void) { eaddr=yreg+6;return 1; }
static byte fetch_0x27(void) { eaddr=yreg+7;return 1; }
static byte fetch_0x28(void) { eaddr=yreg+8;return 1; }
static byte fetch_0x29(void) { eaddr=yreg+9;return 1; }
static byte fetch_0x2A(void) { eaddr=yreg+10;return 1; }
static byte fetch_0x2B(void) { eaddr=yreg+11;return 1; }
static byte fetch_0x2C(void) { eaddr=yreg+12;return 1; }
static byte fetch_0x2D(void) { eaddr=yreg+13;return 1; }
static byte fetch_0x2E(void) { eaddr=yreg+14;return 1; }
static byte fetch_0x2F(void) { eaddr=yreg+15;return 1; }
static byte fetch_0x30(void) { eaddr=yreg-16;return 1; }
static byte fetch_0x31(void) { eaddr=yreg-15;return 1; }
static byte fetch_0x32(void) { eaddr=yreg-14;return 1; }
static byte fetch_0x33(void) { eaddr=yreg-13;return 1; }
static byte fetch_0x34(void) { eaddr=yreg-12;return 1; }
static byte fetch_0x35(void) { eaddr=yreg-11;return 1; }
static byte fetch_0x36(void) { eaddr=yreg-10;return 1; }
static byte fetch_0x37(void) { eaddr=yreg-9;return 1; }
static byte fetch_0x38(void) { eaddr=yreg-8;return 1; }
static byte fetch_0x39(void) { eaddr=yreg-7;return 1; }
static byte fetch_0x3A(void) { eaddr=yreg-6;return 1; }
static byte fetch_0x3B(void) { eaddr=yreg-5;return 1; }
static byte fetch_0x3C(void) { eaddr=yreg-4;return 1; }
static byte fetch_0x3D(void) { eaddr=yreg-3;return 1; }
static byte fetch_0x3E(void) { eaddr=yreg-2;return 1; }
static byte fetch_0x3F(void) { eaddr=yreg-1;return 1; }
static byte fetch_0x40(void) { eaddr=ureg;return 1; }
static byte fetch_0x41(void) { eaddr=ureg+1;return 1; }
static byte fetch_0x42(void) { eaddr=ureg+2;return 1; }
static byte fetch_0x43(void) { eaddr=ureg+3;return 1; }
static byte fetch_0x44(void) { eaddr=ureg+4;return 1; }
static byte fetch_0x45(void) { eaddr=ureg+5;return 1; }
static byte fetch_0x46(void) { eaddr=ureg+6;return 1; }
static byte fetch_0x47(void) { eaddr=ureg+7;return 1; }
static byte fetch_0x48(void) { eaddr=ureg+8;return 1; }
static byte fetch_0x49(void) { eaddr=ureg+9;return 1; }
static byte fetch_0x4A(void) { eaddr=ureg+10;return 1; }
static byte fetch_0x4B(void) { eaddr=ureg+11;return 1; }
static byte fetch_0x4C(void) { eaddr=ureg+12;return 1; }
static byte fetch_0x4D(void) { eaddr=ureg+13;return 1; }
static byte fetch_0x4E(void) { eaddr=ureg+14;return 1; }
static byte fetch_0x4F(void) { eaddr=ureg+15;return 1; }
static byte fetch_0x50(void) { eaddr=ureg-16;return 1; }
static byte fetch_0x51(void) { eaddr=ureg-15;return 1; }
static byte fetch_0x52(void) { eaddr=ureg-14;return 1; }
static byte fetch_0x53(void) { eaddr=ureg-13;return 1; }
static byte fetch_0x54(void) { eaddr=ureg-12;return 1; }
static byte fetch_0x55(void) { eaddr=ureg-11;return 1; }
static byte fetch_0x56(void) { eaddr=ureg-10;return 1; }
static byte fetch_0x57(void) { eaddr=ureg-9;return 1; }
static byte fetch_0x58(void) { eaddr=ureg-8;return 1; }
static byte fetch_0x59(void) { eaddr=ureg-7;return 1; }
static byte fetch_0x5A(void) { eaddr=ureg-6;return 1; }
static byte fetch_0x5B(void) { eaddr=ureg-5;return 1; }
static byte fetch_0x5C(void) { eaddr=ureg-4;return 1; }
static byte fetch_0x5D(void) { eaddr=ureg-3;return 1; }
static byte fetch_0x5E(void) { eaddr=ureg-2;return 1; }
static byte fetch_0x5F(void) { eaddr=ureg-1;return 1; }
static byte fetch_0x60(void) { eaddr=sreg;return 1; }
static byte fetch_0x61(void) { eaddr=sreg+1;return 1; }
static byte fetch_0x62(void) { eaddr=sreg+2;return 1; }
static byte fetch_0x63(void) { eaddr=sreg+3;return 1; }
static byte fetch_0x64(void) { eaddr=sreg+4;return 1; }
static byte fetch_0x65(void) { eaddr=sreg+5;return 1; }
static byte fetch_0x66(void) { eaddr=sreg+6;return 1; }
static byte fetch_0x67(void) { eaddr=sreg+7;return 1; }
static byte fetch_0x68(void) { eaddr=sreg+8;return 1; }
static byte fetch_0x69(void) { eaddr=sreg+9;return 1; }
static byte fetch_0x6A(void) { eaddr=sreg+10;return 1; }
static byte fetch_0x6B(void) { eaddr=sreg+11;return 1; }
static byte fetch_0x6C(void) { eaddr=sreg+12;return 1; }
static byte fetch_0x6D(void) { eaddr=sreg+13;return 1; }
static byte fetch_0x6E(void) { eaddr=sreg+14;return 1; }
static byte fetch_0x6F(void) { eaddr=sreg+15;return 1; }
static byte fetch_0x70(void) { eaddr=sreg-16;return 1; }
static byte fetch_0x71(void) { eaddr=sreg-15;return 1; }
static byte fetch_0x72(void) { eaddr=sreg-14;return 1; }
static byte fetch_0x73(void) { eaddr=sreg-13;return 1; }
static byte fetch_0x74(void) { eaddr=sreg-12;return 1; }
static byte fetch_0x75(void) { eaddr=sreg-11;return 1; }
static byte fetch_0x76(void) { eaddr=sreg-10;return 1; }
static byte fetch_0x77(void) { eaddr=sreg-9;return 1; }
static byte fetch_0x78(void) { eaddr=sreg-8;return 1; }
static byte fetch_0x79(void) { eaddr=sreg-7;return 1; }
static byte fetch_0x7A(void) { eaddr=sreg-6;return 1; }
static byte fetch_0x7B(void) { eaddr=sreg-5;return 1; }
static byte fetch_0x7C(void) { eaddr=sreg-4;return 1; }
static byte fetch_0x7D(void) { eaddr=sreg-3;return 1; }
static byte fetch_0x7E(void) { eaddr=sreg-2;return 1; }
static byte fetch_0x7F(void) { eaddr=sreg-1;return 1; }
static byte fetch_0x80(void) { eaddr=xreg;xreg++;return 2; }
static byte fetch_0x81(void) { eaddr=xreg;xreg+=2;return 3; }
static byte fetch_0x82(void) { xreg--;eaddr=xreg;return 2; }
static byte fetch_0x83(void) { xreg-=2;eaddr=xreg;return 3; }
static byte fetch_0x84(void) { eaddr=xreg; return 0; }
static byte fetch_0x85(void) { eaddr=xreg+SIGNED(breg);return 1; }
static byte fetch_0x86(void) { eaddr=xreg+SIGNED(areg);return 1; }
static byte fetch_0x88(void) { IMMBYTE(eaddr);eaddr=xreg+SIGNED(eaddr);return 1; /* this is a hack to make Vectrex work. It should be return 1. Dunno where the cycle was lost (void) {( */ }
static byte fetch_0x89(void) { IMMWORD(eaddr);eaddr+=xreg;return 4; }
static byte fetch_0x8B(void) { eaddr=xreg+GETDREG;return 4; }
static byte fetch_0x8C(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);return 1; }
static byte fetch_0x8D(void) { IMMWORD(eaddr);eaddr+=pcreg;return 5; }
static byte fetch_0x8F(void) { IMMWORD(eaddr);return 5; }
static byte fetch_0x90(void) { eaddr=xreg;xreg++;eaddr=M_RDMEM_WORD(eaddr);return 5; /* Indirect ,R+ not in my specs */ }
static byte fetch_0x91(void) { eaddr=xreg;xreg+=2;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0x92(void) { xreg--;eaddr=xreg;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0x93(void) { xreg-=2;eaddr=xreg;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0x94(void) { eaddr=xreg;eaddr=M_RDMEM_WORD(eaddr);return 3; }
static byte fetch_0x95(void) { eaddr=xreg+SIGNED(breg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0x96(void) { eaddr=xreg+SIGNED(areg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0x98(void) { IMMBYTE(eaddr);eaddr=xreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0x99(void) { IMMWORD(eaddr);eaddr+=xreg;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0x9B(void) { eaddr=xreg+GETDREG;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0x9C(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0x9D(void) { IMMWORD(eaddr);eaddr+=pcreg;eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0x9F(void) { IMMWORD(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xA0(void) { eaddr=yreg;yreg++;return 2; }
static byte fetch_0xA1(void) { eaddr=yreg;yreg+=2;return 3; }
static byte fetch_0xA2(void) { yreg--;eaddr=yreg;return 2; }
static byte fetch_0xA3(void) { yreg-=2;eaddr=yreg;return 3; }
static byte fetch_0xA4(void) { eaddr=yreg; return 0; }
static byte fetch_0xA5(void) { eaddr=yreg+SIGNED(breg);return 1; }
static byte fetch_0xA6(void) { eaddr=yreg+SIGNED(areg);return 1; }
static byte fetch_0xA8(void) { IMMBYTE(eaddr);eaddr=yreg+SIGNED(eaddr);return 1; }
static byte fetch_0xA9(void) { IMMWORD(eaddr);eaddr+=yreg;return 4; }
static byte fetch_0xAB(void) { eaddr=yreg+GETDREG;return 4; }
static byte fetch_0xAC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);return 1; }
static byte fetch_0xAD(void) { IMMWORD(eaddr);eaddr+=pcreg;return 5; }
static byte fetch_0xAF(void) { IMMWORD(eaddr);return 5; }
static byte fetch_0xB0(void) { eaddr=yreg;yreg++;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xB1(void) { eaddr=yreg;yreg+=2;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xB2(void) { yreg--;eaddr=yreg;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xB3(void) { yreg-=2;eaddr=yreg;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xB4(void) { eaddr=yreg;eaddr=M_RDMEM_WORD(eaddr);return 3; }
static byte fetch_0xB5(void) { eaddr=yreg+SIGNED(breg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xB6(void) { eaddr=yreg+SIGNED(areg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xB8(void) { IMMBYTE(eaddr);eaddr=yreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xB9(void) { IMMWORD(eaddr);eaddr+=yreg;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xBB(void) { eaddr=yreg+GETDREG;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xBC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xBD(void) { IMMWORD(eaddr);eaddr+=pcreg;eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xBF(void) { IMMWORD(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xC0(void) { eaddr=ureg;ureg++;return 2; }
static byte fetch_0xC1(void) { eaddr=ureg;ureg+=2;return 3; }
static byte fetch_0xC2(void) { ureg--;eaddr=ureg;return 2; }
static byte fetch_0xC3(void) { ureg-=2;eaddr=ureg;return 3; }
static byte fetch_0xC4(void) { eaddr=ureg; return 0; }
static byte fetch_0xC5(void) { eaddr=ureg+SIGNED(breg);return 1; }
static byte fetch_0xC6(void) { eaddr=ureg+SIGNED(areg);return 1; }
static byte fetch_0xC8(void) { IMMBYTE(eaddr);eaddr=ureg+SIGNED(eaddr);return 1; }
static byte fetch_0xC9(void) { IMMWORD(eaddr);eaddr+=ureg;return 4; }
static byte fetch_0xCB(void) { eaddr=ureg+GETDREG;return 4; }
static byte fetch_0xCC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);return 1; }
static byte fetch_0xCD(void) { IMMWORD(eaddr);eaddr+=pcreg;return 5; }
static byte fetch_0xCF(void) { IMMWORD(eaddr);return 5; }
static byte fetch_0xD0(void) { eaddr=ureg;ureg++;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xD1(void) { eaddr=ureg;ureg+=2;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xD2(void) { ureg--;eaddr=ureg;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xD3(void) { ureg-=2;eaddr=ureg;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xD4(void) { eaddr=ureg;eaddr=M_RDMEM_WORD(eaddr);return 3; }
static byte fetch_0xD5(void) { eaddr=ureg+SIGNED(breg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xD6(void) { eaddr=ureg+SIGNED(areg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xD8(void) { IMMBYTE(eaddr);eaddr=ureg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xD9(void) { IMMWORD(eaddr);eaddr+=ureg;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xDB(void) { eaddr=ureg+GETDREG;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xDC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xDD(void) { IMMWORD(eaddr);eaddr+=pcreg;eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xDF(void) { IMMWORD(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xE0(void) { eaddr=sreg;sreg++;return 2; }
static byte fetch_0xE1(void) { eaddr=sreg;sreg+=2;return 3; }
static byte fetch_0xE2(void) { sreg--;eaddr=sreg;return 2; }
static byte fetch_0xE3(void) { sreg-=2;eaddr=sreg;return 3; }
static byte fetch_0xE4(void) { eaddr=sreg; return 0; }
static byte fetch_0xE5(void) { eaddr=sreg+SIGNED(breg);return 1; }
static byte fetch_0xE6(void) { eaddr=sreg+SIGNED(areg);return 1; }
static byte fetch_0xE8(void) { IMMBYTE(eaddr);eaddr=sreg+SIGNED(eaddr);return 1; }
static byte fetch_0xE9(void) { IMMWORD(eaddr);eaddr+=sreg;return 4; }
static byte fetch_0xEB(void) { eaddr=sreg+GETDREG;return 4; }
static byte fetch_0xEC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);return 1; }
static byte fetch_0xED(void) { IMMWORD(eaddr);eaddr+=pcreg;return 5; }
static byte fetch_0xEF(void) { IMMWORD(eaddr);return 5; }
static byte fetch_0xF0(void) { eaddr=sreg;sreg++;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xF1(void) { eaddr=sreg;sreg+=2;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xF2(void) { sreg--;eaddr=sreg;eaddr=M_RDMEM_WORD(eaddr);return 5; }
static byte fetch_0xF3(void) { sreg-=2;eaddr=sreg;eaddr=M_RDMEM_WORD(eaddr);return 6; }
static byte fetch_0xF4(void) { eaddr=sreg;eaddr=M_RDMEM_WORD(eaddr);return 3; }
static byte fetch_0xF5(void) { eaddr=sreg+SIGNED(breg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xF6(void) { eaddr=sreg+SIGNED(areg);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xF8(void) { IMMBYTE(eaddr);eaddr=sreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xF9(void) { IMMWORD(eaddr);eaddr+=sreg;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xFB(void) { eaddr=sreg+GETDREG;eaddr=M_RDMEM_WORD(eaddr);return 7; }
static byte fetch_0xFC(void) { IMMBYTE(eaddr);eaddr=pcreg+SIGNED(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 4; }
static byte fetch_0xFD(void) { IMMWORD(eaddr);eaddr+=pcreg;eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_0xFF(void) { IMMWORD(eaddr);eaddr=M_RDMEM_WORD(eaddr);return 8; }
static byte fetch_dflt(void) { eaddr=0; return 0; /*ILLEGAL*/ }

static byte (*m6809_fetch[0x100])(void) = {
	fetch_0x00, fetch_0x01, fetch_0x02, fetch_0x03, fetch_0x04, fetch_0x05, fetch_0x06, fetch_0x07,
	fetch_0x08, fetch_0x09, fetch_0x0A, fetch_0x0B, fetch_0x0C, fetch_0x0D, fetch_0x0E, fetch_0x0F, 
	fetch_0x10, fetch_0x11, fetch_0x12, fetch_0x13, fetch_0x14, fetch_0x15, fetch_0x16, fetch_0x17, 
	fetch_0x18, fetch_0x19, fetch_0x1A, fetch_0x1B, fetch_0x1C, fetch_0x1D, fetch_0x1E, fetch_0x1F, 
	fetch_0x20, fetch_0x21, fetch_0x22, fetch_0x23, fetch_0x24, fetch_0x25, fetch_0x26, fetch_0x27, 
	fetch_0x28, fetch_0x29, fetch_0x2A, fetch_0x2B, fetch_0x2C, fetch_0x2D, fetch_0x2E, fetch_0x2F, 
	fetch_0x30, fetch_0x31, fetch_0x32, fetch_0x33, fetch_0x34, fetch_0x35, fetch_0x36, fetch_0x37, 
	fetch_0x38, fetch_0x39, fetch_0x3A, fetch_0x3B, fetch_0x3C, fetch_0x3D, fetch_0x3E, fetch_0x3F, 
	fetch_0x40, fetch_0x41, fetch_0x42, fetch_0x43, fetch_0x44, fetch_0x45, fetch_0x46, fetch_0x47, 
	fetch_0x48, fetch_0x49, fetch_0x4A, fetch_0x4B, fetch_0x4C, fetch_0x4D, fetch_0x4E, fetch_0x4F, 
	fetch_0x50, fetch_0x51, fetch_0x52, fetch_0x53, fetch_0x54, fetch_0x55, fetch_0x56, fetch_0x57, 
	fetch_0x58, fetch_0x59, fetch_0x5A, fetch_0x5B, fetch_0x5C, fetch_0x5D, fetch_0x5E, fetch_0x5F, 
	fetch_0x60, fetch_0x61, fetch_0x62, fetch_0x63, fetch_0x64, fetch_0x65, fetch_0x66, fetch_0x67, 
	fetch_0x68, fetch_0x69, fetch_0x6A, fetch_0x6B, fetch_0x6C, fetch_0x6D, fetch_0x6E, fetch_0x6F, 
	fetch_0x70, fetch_0x71, fetch_0x72, fetch_0x73, fetch_0x74, fetch_0x75, fetch_0x76, fetch_0x77, 
	fetch_0x78, fetch_0x79, fetch_0x7A, fetch_0x7B, fetch_0x7C, fetch_0x7D, fetch_0x7E, fetch_0x7F, 
	fetch_0x80, fetch_0x81, fetch_0x82, fetch_0x83, fetch_0x84, fetch_0x85, fetch_0x86, fetch_dflt,
	fetch_0x88, fetch_0x89, fetch_dflt, fetch_0x8B, fetch_0x8C, fetch_0x8D, fetch_dflt, fetch_0x8F, 
	fetch_0x90, fetch_0x91, fetch_0x92, fetch_0x93, fetch_0x94, fetch_0x95, fetch_0x96, fetch_dflt,
	fetch_0x98, fetch_0x99, fetch_dflt, fetch_0x9B, fetch_0x9C, fetch_0x9D, fetch_dflt, fetch_0x9F,
	fetch_0xA0, fetch_0xA1, fetch_0xA2, fetch_0xA3, fetch_0xA4, fetch_0xA5, fetch_0xA6, fetch_dflt,
	fetch_0xA8, fetch_0xA9, fetch_dflt, fetch_0xAB, fetch_0xAC, fetch_0xAD, fetch_dflt, fetch_0xAF, 
	fetch_0xB0, fetch_0xB1, fetch_0xB2, fetch_0xB3, fetch_0xB4, fetch_0xB5, fetch_0xB6, fetch_dflt,
	fetch_0xB8, fetch_0xB9, fetch_dflt, fetch_0xBB, fetch_0xBC, fetch_0xBD, fetch_dflt, fetch_0xBF, 
	fetch_0xC0, fetch_0xC1, fetch_0xC2, fetch_0xC3, fetch_0xC4, fetch_0xC5, fetch_0xC6, fetch_dflt,
	fetch_0xC8, fetch_0xC9, fetch_dflt, fetch_0xCB, fetch_0xCC, fetch_0xCD, fetch_dflt, fetch_0xCF, 
	fetch_0xD0, fetch_0xD1, fetch_0xD2, fetch_0xD3, fetch_0xD4, fetch_0xD5, fetch_0xD6, fetch_dflt,
	fetch_0xD8, fetch_0xD9, fetch_dflt, fetch_0xDB, fetch_0xDC, fetch_0xDD, fetch_dflt, fetch_0xDF, 
	fetch_0xE0, fetch_0xE1, fetch_0xE2, fetch_0xE3, fetch_0xE4, fetch_0xE5, fetch_0xE6, fetch_dflt,
	fetch_0xE8, fetch_0xE9, fetch_dflt, fetch_0xEB, fetch_0xEC, fetch_0xED, fetch_dflt, fetch_0xEF, 
	fetch_0xF0, fetch_0xF1, fetch_0xF2, fetch_0xF3, fetch_0xF4, fetch_0xF5, fetch_0xF6, fetch_dflt,
	fetch_0xF8, fetch_0xF9, fetch_dflt, fetch_0xFB, fetch_0xFC, fetch_0xFD, fetch_dflt, fetch_0xFF
};
